//Integrator, der ein Runge-Kutta-Verfahren verwendet.
//Bei Aufruf des Konstruktors wird ein Zeiger auf das zu integrierende Modell im 
//Integrator-Objekt gespeichert.
public class Integrator
{
    public Integrator(Modell modell)
    {
        this.modell = modell;
        yneu = new double[modell.holeAnzahlGleichungen()];
        yhilf = new double[modell.holeAnzahlGleichungen()];
        k1 = new double[modell.holeAnzahlGleichungen()]; 
        k2 = new double[modell.holeAnzahlGleichungen()]; 
        k3 = new double[modell.holeAnzahlGleichungen()]; 
        k4 = new double[modell.holeAnzahlGleichungen()]; 
    }
    double[] zeitschritt(double[] yalt,double t,double dt)
    {
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            k1[i] = modell.rechteSeite(yalt,t,i);
            yhilf[i] = yalt[i] + 0.5*dt*k1[i];
        }                
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            k2[i] = modell.rechteSeite(yhilf,t,i);
            yhilf[i] = yalt[i] + 0.5*dt*k2[i];
        }                
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            k3[i] = modell.rechteSeite(yhilf,t,i);
            yhilf[i] = yalt[i] + dt*k3[i];
        }                
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            k4[i] = modell.rechteSeite(yhilf,t,i);
        }                
        for(int i=0;i<modell.holeAnzahlGleichungen();i++)
        {
            yneu[i] = yalt[i] + (dt/6.0)*(k1[i]+2.0*k2[i]+2.0*k3[i]+k4[i]);
        }                

        modell.ringindex++;
        modell.ringindex%=modell.utot.length;

        return yneu;
    } 
    
    private Modell modell;
    private double[] yneu;
    private double[] yhilf;
    private double[] k1,k2,k3,k4;
}
