public class Modell
{
    private int anzahl=3;
    public  double[] par;

    public double[] utot;
    public int ringindex=0;

    public String[] param_beschreibung = 
    {
        //Nr.,  Symbol,   Minwert,  Maxwert, Startwert,        Bezeichnung,  Gruppe
          "0",    "t0",     "0.0",  "100.0",     "0.0",        "Startzeit",  "Simulations-Parameter",
          "1",  "tdur",     "0.0",  "100.0",    "10.0", "Simulationsdauer",  "Simulations-Parameter",
          "2",    "dt",  "0.0001",    "1.0",    "0.01",     "Schrittweite",  "Simulations-Parameter",

          "3",     "K",     "0.0",  "100.0",    "10.0",      "Verstrkung",  "PID-Regler R(s) = K*(1+1/(Tn*s)+Tv*s)",
          "4",   "RTn",     "0.0",  "100.0",     "0.0",  "1/Nachstellzeit",  "PID-Regler R(s) = K*(1+1/(Tn*s)+Tv*s)",
          "5",    "Tv",     "0.0",  "100.0",     "0.0",     "Vorhaltezeit",  "PID-Regler R(s) = K*(1+1/(Tn*s)+Tv*s)",
          "6",     "w",     "0.0",   "10.0",     "0.7",    "Fhrungsgre",  "PID-Regler R(s) = K*(1+1/(Tn*s)+Tv*s)",

          "7",     "a",     "0.0",  "100.0",     "1.0",                 "",  "PT2: G(s)=1/(a+b*s+c*s^2)",
          "8",     "b",     "0.0",  "100.0",     "2.0",                 "",  "PT2: G(s)=1/(a+b*s+c*s^2)",
          "9",     "c",     "0.0",  "100.0",     "1.0",                 "",  "PT2: G(s)=1/(a+b*s+c*s^2)",
         "10",    "Tt",     "0.0",   "10.0",     "0.1",          "Totzeit",  "PT2: G(s)=1/(a+b*s+c*s^2)"
    };
    
    public Modell()  
    {
        par = new double[param_beschreibung.length/7];
        for(int i=0;i<par.length;i++)
            par[i]=Double.parseDouble(param_beschreibung[4+i*7]);

        //Zwischenspeicher fr das Totzeitverhalten bereitstellen:
        int tanz = (int)(p("Tt")/p("dt"));
        utot = new double[tanz];
        for(int i=0;i<utot.length;i++)
            utot[i]=0.0;
    }

    public double p(String name)
    {
        for(int i=1;i<param_beschreibung.length;i+=7)
            if(param_beschreibung[i].equals(name))
                return par[(i-1)/7];
        return 0.0;
    }

    public double rechteSeite(double[] y,double t, int zeile)
    {
        double e = p("w") - y[0]; 
//        if(t>0.5*p("tdur"))
//            e = 2.0*p("w") - y[0]; 
        double u = p("K")*(  1.0*e + p("RTn")*y[2] - p("Tv")*y[1]  );
        utot[ringindex]=u;

        double f=0.0;
        switch(zeile)
        {
            case 0:
                f = y[1];
            break;
            case 1:
                f = -(p("a")/p("c"))*y[0]-(p("b")/p("c"))*y[1]+utot[(ringindex+1)%utot.length]/p("c"); 
            break;                    
            case 2:
                f = e; 
            break;                    
            default:
                f = 0.0;
            break;                                                                                            
        }              
        return f; 
    }
    public int holeAnzahlGleichungen()
    {
        return anzahl;
    } 
} 
